


<h1><a name="git" id="git">Git</a></h1>
<div class="level1">

<p>

<a href="http://git-scm.com/" class="urlextern" title="http://git-scm.com/"  rel="nofollow">Git</a>: <a href="http://en.wikipedia.org/wiki/Git_(software)" class="interwiki iw_wp" title="http://en.wikipedia.org/wiki/Git_(software)">Git</a> <br/>

</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Git" [1-78] -->
<h2><a name="how_to_install_git" id="how_to_install_git">How to install Git</a></h2>
<div class="level2">
<pre class="code bash">$ <span class="kw2">sudo</span> <span class="kw2">apt-get</span> <span class="kw2">install</span> git-core
$ git config <span class="re5">--global</span> user.name user_name
$ git config <span class="re5">--global</span> user.email you<span class="sy0">@</span>yourdomain.example.com</pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to install Git" [79-264] -->
<h2><a name="how_to_create_a_ssh_key" id="how_to_create_a_ssh_key">How to create a SSH key</a></h2>
<div class="level2">
<pre class="code bash">$ <span class="kw2">ssh-keygen</span></pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to create a SSH key" [265-336] -->
<h2><a name="how_to_create_a_project" id="how_to_create_a_project">How to create a project</a></h2>
<div class="level2">

<p>

Using <a href="http://repo.or.cz" class="urlextern" title="http://repo.or.cz"  rel="nofollow">Repo Public Git Hosting</a>
</p>
<pre class="code bash">$ <span class="kw3">cd</span> path<span class="sy0">/</span>to<span class="sy0">/</span>project
$ git init
$ git add .
$ git commit <span class="re5">-a</span> <span class="re5">-m</span><span class="st0">&quot;message&quot;</span>
$ git remote add origin <span class="kw2">ssh</span>:<span class="sy0">//</span>user_name<span class="sy0">@</span>repo.or.cz<span class="sy0">/</span>srv<span class="sy0">/</span>git<span class="sy0">/</span>project_name.git
$ git push <span class="re5">--all</span> origin</pre>

<p>
Using <a href="https://github.com/" class="urlextern" title="https://github.com/"  rel="nofollow">GitHub</a>
</p>
<pre class="code bash">$ <span class="kw2">mkdir</span> project_name
$ <span class="kw3">cd</span> project_name
$ git init
$ <span class="kw2">touch</span> README
$ git add README
$ git commit <span class="re5">-m</span> <span class="st_h">'first commit'</span>
$ git remote add origin git<span class="sy0">@</span>github.com:user_name<span class="sy0">/</span>project_name.git
$ git push origin master</pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to create a project" [337-882] -->
<h2><a name="how_to_download_a_project" id="how_to_download_a_project">How to download a project</a></h2>
<div class="level2">

<p>

Using <a href="http://repo.or.cz" class="urlextern" title="http://repo.or.cz"  rel="nofollow">Repo Public Git Hosting</a>
</p>
<pre class="code bash">$ git clone git:<span class="sy0">//</span>repo.or.cz<span class="sy0">/</span>project_name.git
$ <span class="kw3">cd</span> project_name</pre>

<p>
Using <a href="https://github.com/" class="urlextern" title="https://github.com/"  rel="nofollow">GitHub</a>
</p>
<pre class="code bash">$ git clone http:<span class="sy0">//</span>github.com<span class="sy0">/</span>user_name<span class="sy0">/</span>project_name.git
$ <span class="kw3">cd</span> project_name</pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to download a project" [883-1193] -->
<h2><a name="how_to_upload_a_project" id="how_to_upload_a_project">How to upload a project</a></h2>
<div class="level2">

<p>

Just the first time:
</p>

<p>
Using <a href="http://repo.or.cz" class="urlextern" title="http://repo.or.cz"  rel="nofollow">Repo Public Git Hosting</a>
</p>
<pre class="code bash">$ git remote <span class="kw2">rm</span> origin
$ git remote add origin <span class="kw2">ssh</span>:<span class="sy0">//</span>user_name<span class="sy0">@</span>repo.or.cz<span class="sy0">/</span>srv<span class="sy0">/</span>git<span class="sy0">/</span>project_name.git</pre>

<p>
Using <a href="https://github.com/" class="urlextern" title="https://github.com/"  rel="nofollow">GitHub</a>
</p>
<pre class="code bash">$ git remote <span class="kw2">rm</span> origin
$ git remote add origin git<span class="sy0">@</span>github.com:user_name<span class="sy0">/</span>project_name.git</pre>

<p>
Always:

</p>
<pre class="code bash">$ git add .
$ git commit <span class="re5">-a</span> <span class="re5">-m</span><span class="st0">&quot;description of the modifications&quot;</span>
$ git push <span class="re5">--all</span> origin</pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to upload a project" [1194-1691] -->
<h2><a name="how_to_update_your_version_of_a_project" id="how_to_update_your_version_of_a_project">How to update your version of a project</a></h2>
<div class="level2">
<pre class="code bash">$ git pull origin master</pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to update your version of a project" [1692-1792] -->
<h2><a name="how_to_create_a_tag" id="how_to_create_a_tag">How to create a tag</a></h2>
<div class="level2">
<pre class="code bash">$ git tag tag_name</pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to create a tag" [1793-1865] -->
<h2><a name="how_to_upload_a_tag" id="how_to_upload_a_tag">How to upload a tag</a></h2>
<div class="level2">
<pre class="code bash">$ git push origin tag_name</pre>

<p>
or
</p>
<pre class="code bash">$ git push <span class="re5">--tags</span> origin</pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to upload a tag" [1866-1996] -->
<h2><a name="git_cheat_sheet" id="git_cheat_sheet">Git Cheat Sheet</a></h2>
<div class="level2">

<p>

<a href="http://cheat.errtheblog.com/s/git?utm_source=twitter&amp;utm_medium=micro-blog&amp;utm_campaign=twitter" class="urlextern" title="http://cheat.errtheblog.com/s/git?utm_source=twitter&amp;utm_medium=micro-blog&amp;utm_campaign=twitter"  rel="nofollow">Cheat Git</a>
</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Git Cheat Sheet" [1997-2136] -->
<h2><a name="resumo_em_portugues" id="resumo_em_portugues">Resumo em português</a></h2>
<div class="level2">
<pre class="code bash">Tens que te cadastrar no github e me dizer teu usuário para poderes dar pull
&nbsp;
http:<span class="sy0">//</span>github.com<span class="sy0">/</span>kssilveira<span class="sy0">/</span>CTipsAndTricks
&nbsp;
chave <span class="kw2">ssh</span>:
<span class="kw2">cat</span> ~<span class="sy0">/</span>.ssh<span class="sy0">/</span>id_rsa.pub
caso o arquivo exista, coloca o conteú<span class="kw1">do</span> dele na tua lista de chaves <span class="kw2">ssh</span> no teu perfil <span class="kw1">do</span> git hub
caso não exista:
   <span class="kw2">ssh-keygen</span>
   <span class="br0">&#123;</span>enter<span class="br0">&#125;</span>
   escolhe uma senha
   goto chave <span class="kw2">ssh</span>
&nbsp;
git config <span class="re5">--global</span> user.name <span class="st0">&quot;Bruno Jurkovski&quot;</span>
git config <span class="re5">--global</span> user.email bjurkovski<span class="sy0">@</span>gmail.com
git clone git<span class="sy0">@</span>github.com:kssilveira<span class="sy0">/</span>CTipsAndTricks.git
... edita ...
git status
... <span class="kw2">make</span> clean nas pastas com os slides ... apagar <span class="sy0">*</span>~, <span class="sy0">*</span>.o, executáveis e etc. de todas <span class="kw2">as</span> pastas ...
git status
... ver se tem apenas arquivos que não são derivados <span class="br0">&#40;</span>além dos pdfs<span class="br0">&#41;</span> ...
git add .
git status
... verificar novamente ...
git commit <span class="re5">-a</span> <span class="re5">-m</span><span class="st0">&quot;descrição&quot;</span>
... isso cria uma versão <span class="kw3">local</span> <span class="br0">&#40;</span>só na tua máquina<span class="br0">&#41;</span>, que funciona da mesma forma que se tivesse no servidor ...
git push <span class="re5">--all</span> origin
... upload para o servidor ...
git pull origin master
... download <span class="kw1">do</span> servidor ...</pre>
<div class="tags"><span>
	<a href="/~kssilveira/site/doku.php?id=tag:programming&amp;do=showtag&amp;tag=tag%3Aprogramming" class="wikilink1" title="tag:programming" rel="tag">programming</a>
</span></div>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Resumo em português" [2137-] -->